function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
import { renderless, api } from "@xmweb-ui/vue-renderless/card/vue";
import { defineComponent, $prefix, $props, setup as _setup } from "@xmweb-ui/vue-common";
import Dropdown from "@xmweb-ui/vue-dropdown";
import DropdownMenu from "@xmweb-ui/vue-dropdown-menu";
import DropdownItem from "@xmweb-ui/vue-dropdown-item";
import Checkbox from "@xmweb-ui/vue-checkbox";
import Radio from "@xmweb-ui/vue-radio";
import { IconEllipsis } from "@xmweb-ui/vue-icon";
import { resolveComponent, openBlock, createElementBlock, normalizeClass, createElementVNode, createVNode, createCommentVNode, withCtx, renderSlot, toDisplayString, normalizeStyle, Fragment, renderList, createBlock, resolveDynamicComponent } from "vue";
function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (it)
    return (it = it.call(o)).next.bind(it);
  if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
    if (it)
      o = it;
    var i = 0;
    return function() {
      if (i >= o.length)
        return { done: true };
      return { done: false, value: o[i++] };
    };
  }
  throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o)
    return;
  if (typeof o === "string")
    return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor)
    n = o.constructor.name;
  if (n === "Map" || n === "Set")
    return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))
    return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length)
    len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++)
    arr2[i] = arr[i];
  return arr2;
}
var _export_sfc = function _export_sfc2(sfc, props) {
  var target = sfc.__vccOpts || sfc;
  for (var _iterator = _createForOfIteratorHelperLoose(props), _step; !(_step = _iterator()).done; ) {
    var _step$value = _step.value, key = _step$value[0], val = _step$value[1];
    target[key] = val;
  }
  return target;
};

var classes = {
  "card": "overflow-hidden bg-color-bg-1 border hover:shadow",
  "size-large": "rounded-lg min-w-[31.25rem]",
  "size-medium": "rounded-lg min-w-[18.75rem]",
  "size-small": "rounded-lg min-w-[12.5rem]",
  "size-mini": "rounded min-w-[6.25rem]",
  "size-large-padding": "p-4",
  "size-medium-padding": "p-3",
  "size-small-padding": "p-3",
  "size-mini-padding": "p-2",
  "size-large-width": "w-[37.5rem]",
  "size-medium-width": "w-[25rem]",
  "size-small-width": "w-[18.75rem]",
  "size-mini-width": "w-[11.25rem]",
  "status-success": "border-color-success",
  "status-warning": "border-color-warning",
  "status-alerting": "border-color-alert",
  "status-danger": "border-color-error",
  "status-default": "border-color-border-separator",
  "title": "text-base sm:text-sm mb-3 leading-[1.375rem] text-color-text-primary mr-2",
  "checkbox": "relative left-1 pt-3 sm:pt-[0.875rem] pl-2 [&_[data-tag=xm-checkbox]]:p-0 [&_[data-tag=xm-checkbox]>span>span]:p-0 [&_[data-tag=xm-checkbox]>span:nth-child(2)]:hidden",
  "radio": "relative left-0 sm:left-3 pt-0 sm:pt-3 [&_[role=radio]_span_span]:pr-0",
  "logo": "flex mb-3 w-full justify-center items-center aspect-[2_/_1] overflow-hidden",
  "main": "text-sm sm:text-xs text-color-text-secondary overflow-y-auto",
  "footer": "p-3 border-t border-t-color-border-separator",
  "options": "w-full px-3 h-[2.625rem] flex items-center justify-around text-color-text-primary border-t border-t-color-border-separator"
};
var $constants = {
  CARD_GROUP: "CardGroup"
};
var _sfc_main = defineComponent({
  name: $prefix + "Card",
  emits: ["icon-click", "update:modelValue", "change"],
  components: {
    XmDropdown: Dropdown,
    XmDropdownMenu: DropdownMenu,
    XmDropdownItem: DropdownItem,
    XmCheckbox: Checkbox,
    XmRadio: Radio,
    IconEllipsis: IconEllipsis()
  },
  props: _extends({}, $props, {
    _constants: {
      type: Object,
      default: function _default() {
        return $constants;
      }
    },
    modelValue: {},
    src: String,
    title: String,
    cardClass: String,
    height: String,
    label: {},
    autoWidth: {
      type: Boolean,
      default: false
    },
    options: {
      type: Array,
      default: function _default2() {
        return [];
      }
    },
    iconMore: {
      type: [Object, String],
      default: function _default3() {
        return IconEllipsis();
      }
    },
    size: {
      type: String,
      default: "medium"
    },
    status: {
      type: String,
      default: "default"
    },
    checkType: {
      type: String,
      default: ""
    },
    type: {
      type: String,
      default: "text"
    },
    disabled: {
      type: Boolean,
      default: false
    }
  }),
  setup: function setup(props, context) {
    return _setup({
      props,
      context,
      renderless,
      api,
      classes,
      mono: true
    });
  }
});
var _hoisted_1 = /* @__PURE__ */ createElementVNode(
  "span",
  null,
  null,
  -1
  /* HOISTED */
);
var _hoisted_2 = {
  key: 2
};
var _hoisted_3 = ["src"];
var _hoisted_4 = {
  key: 3
};
var _hoisted_5 = ["src"];
var _hoisted_6 = ["src"];
var _hoisted_7 = {
  key: 0,
  class: "w-full"
};
var _hoisted_8 = ["onClick"];
var _hoisted_9 = {
  key: 0,
  class: "ml-1 align-middle"
};
var _hoisted_10 = {
  key: 0,
  class: "ml-1 align-middle"
};
var _hoisted_11 = {
  key: 0,
  class: "ml-1 text-color-text-primary"
};
var _hoisted_12 = ["onClick"];
var _hoisted_13 = {
  key: 0
};
function _sfc_render(_ctx, _cache, $props2, $setup, $data, $options) {
  var _component_xm_checkbox = resolveComponent("xm-checkbox");
  var _component_xm_radio = resolveComponent("xm-radio");
  var _component_xm_dropdown_item = resolveComponent("xm-dropdown-item");
  var _component_xm_dropdown_menu = resolveComponent("xm-dropdown-menu");
  var _component_xm_dropdown = resolveComponent("xm-dropdown");
  return openBlock(), createElementBlock(
    "div",
    {
      class: normalizeClass(_ctx.m(_ctx.gcls("card"), _ctx.gcls("size-" + _ctx.state.size), _ctx.gcls("status-" + _ctx.state.status), _ctx.gcls(!_ctx.state.autoWidth && "size-" + _ctx.state.size + "-width"), _ctx.state.itemChecked ? "border-color-brand" : "", _ctx.state.disabled ? "bg-color-bg-2" : "", _ctx.state.cardClass))
    },
    [createElementVNode(
      "div",
      {
        class: normalizeClass([_ctx.state.type === "text" ? "flex" : "block"])
      },
      [_ctx.state.checkType === "checkbox" && _ctx.state.type === "text" ? (openBlock(), createElementBlock(
        "div",
        {
          key: 0,
          class: normalizeClass(_ctx.gcls("checkbox"))
        },
        [createVNode(_component_xm_checkbox, {
          modelValue: _ctx.state.model,
          "onUpdate:modelValue": _cache[0] || (_cache[0] = function($event) {
            return _ctx.state.model = $event;
          }),
          label: _ctx.label,
          disabled: _ctx.state.disabled
        }, null, 8, ["modelValue", "label", "disabled"])],
        2
        /* CLASS */
      )) : createCommentVNode("v-if", true), _ctx.state.checkType === "radio" && _ctx.state.type === "text" ? (openBlock(), createElementBlock(
        "div",
        {
          key: 1,
          class: normalizeClass(_ctx.gcls("radio"))
        },
        [createVNode(_component_xm_radio, {
          modelValue: _ctx.state.model,
          "onUpdate:modelValue": _cache[1] || (_cache[1] = function($event) {
            return _ctx.state.model = $event;
          }),
          label: _ctx.label,
          disabled: _ctx.state.disabled
        }, {
          default: withCtx(function() {
            return [_hoisted_1];
          }),
          _: 1
          /* STABLE */
        }, 8, ["modelValue", "label", "disabled"])],
        2
        /* CLASS */
      )) : createCommentVNode("v-if", true), _ctx.state.type === "image" ? (openBlock(), createElementBlock("div", _hoisted_2, [createElementVNode("img", {
        src: _ctx.src,
        class: "w-full aspect-video bg-cover"
      }, null, 8, _hoisted_3)])) : createCommentVNode("v-if", true), _ctx.state.type === "video" ? (openBlock(), createElementBlock("div", _hoisted_4, [createElementVNode("video", {
        class: "w-full aspect-video",
        src: _ctx.src,
        controls: ""
      }, null, 8, _hoisted_5)])) : createCommentVNode("v-if", true), createElementVNode(
        "div",
        {
          class: normalizeClass(["flex-1", _ctx.gcls("size-" + _ctx.state.size + "-padding")])
        },
        [_ctx.state.type === "logo" ? (openBlock(), createElementBlock(
          "div",
          {
            key: 0,
            class: normalizeClass(_ctx.gcls("logo"))
          },
          [createElementVNode("img", {
            src: _ctx.src,
            class: "bg-contain"
          }, null, 8, _hoisted_6)],
          2
          /* CLASS */
        )) : createCommentVNode("v-if", true), _ctx.title || _ctx.slots.title ? (openBlock(), createElementBlock(
          "div",
          {
            key: 1,
            class: normalizeClass(["flex items-start", [_ctx.state.type === "logo" && "text-center justify-center"]])
          },
          [renderSlot(_ctx.$slots, "title-left"), renderSlot(_ctx.$slots, "title", {}, function() {
            return [createElementVNode(
              "p",
              {
                class: normalizeClass(_ctx.gcls("title"))
              },
              toDisplayString(_ctx.title),
              3
              /* TEXT, CLASS */
            )];
          }), renderSlot(_ctx.$slots, "title-right")],
          2
          /* CLASS */
        )) : createCommentVNode("v-if", true), createElementVNode(
          "div",
          {
            class: normalizeClass(_ctx.m(_ctx.gcls("main"), _ctx.state.type === "logo" ? "text-center" : "")),
            style: normalizeStyle({
              height: _ctx.state.height
            })
          },
          [renderSlot(_ctx.$slots, "default")],
          6
          /* CLASS, STYLE */
        )],
        2
        /* CLASS */
      )],
      2
      /* CLASS */
    ), _ctx.state.effectOptions.length || _ctx.slots.footer ? (openBlock(), createElementBlock("div", _hoisted_7, [_ctx.slots.footer ? (openBlock(), createElementBlock(
      "div",
      {
        key: 0,
        class: normalizeClass(_ctx.gcls("footer"))
      },
      [renderSlot(_ctx.$slots, "footer")],
      2
      /* CLASS */
    )) : createCommentVNode("v-if", true), _ctx.state.effectOptions.length ? (openBlock(), createElementBlock(
      "div",
      {
        key: 1,
        class: normalizeClass(_ctx.gcls("options"))
      },
      [(openBlock(true), createElementBlock(
        Fragment,
        null,
        renderList(_ctx.state.effectOptions.slice(0, _ctx.state.sliceNum), function(item, index) {
          return openBlock(), createElementBlock("div", {
            class: normalizeClass(["cursor-pointer", [item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""]]),
            key: item.text + index,
            onClick: function onClick($event) {
              return _ctx.handelIconClick(item, index, $event);
            }
          }, [(openBlock(), createBlock(resolveDynamicComponent(item.icon), {
            class: normalizeClass(["w-4 h-4", [item.disabled ? "fill-color-icon-disabled" : ""]])
          }, null, 8, ["class"])), item.text ? (openBlock(), createElementBlock(
            "span",
            _hoisted_9,
            toDisplayString(item.text),
            1
            /* TEXT */
          )) : createCommentVNode("v-if", true)], 10, _hoisted_8);
        }),
        128
        /* KEYED_FRAGMENT */
      )), _ctx.state.effectOptions.length === _ctx.state.iconNum ? (openBlock(), createElementBlock(
        "div",
        {
          key: 0,
          class: normalizeClass(["cursor-pointer", [_ctx.state.effectOptions[_ctx.state.sliceNum].disabled ? "text-color-text-disabled cursor-not-allowed" : ""]]),
          onClick: _cache[2] || (_cache[2] = function($event) {
            return _ctx.handelIconClick(_ctx.state.effectOptions[_ctx.state.sliceNum], _ctx.state.sliceNum, $event);
          })
        },
        [(openBlock(), createBlock(resolveDynamicComponent(_ctx.state.effectOptions[_ctx.state.sliceNum].icon), {
          class: normalizeClass(["w-4 h-4", [_ctx.state.effectOptions[_ctx.state.sliceNum].disabled ? "fill-color-icon-disabled" : ""]])
        }, null, 8, ["class"])), _ctx.state.effectOptions[_ctx.state.sliceNum].text ? (openBlock(), createElementBlock(
          "span",
          _hoisted_10,
          toDisplayString(_ctx.state.effectOptions[_ctx.state.sliceNum].text),
          1
          /* TEXT */
        )) : createCommentVNode("v-if", true)],
        2
        /* CLASS */
      )) : createCommentVNode("v-if", true), _ctx.state.effectOptions.length > _ctx.state.iconNum ? (openBlock(), createBlock(_component_xm_dropdown, {
        key: 1,
        "show-self-icon": ""
      }, {
        dropdown: withCtx(function() {
          return [createVNode(_component_xm_dropdown_menu, {
            placement: "bottom"
          }, {
            default: withCtx(function() {
              return [(openBlock(true), createElementBlock(
                Fragment,
                null,
                renderList(_ctx.state.effectOptions.slice(_ctx.state.sliceNum), function(item, index) {
                  return openBlock(), createBlock(
                    _component_xm_dropdown_item,
                    {
                      key: item.text + index
                    },
                    {
                      default: withCtx(function() {
                        return [createElementVNode("div", {
                          onClick: function onClick($event) {
                            return _ctx.handelIconClick(item, index + _ctx.state.sliceNum, $event);
                          },
                          class: normalizeClass(["px-2", item.disabled ? "text-color-text-disabled cursor-not-allowed" : ""])
                        }, [(openBlock(), createBlock(resolveDynamicComponent(item.icon), {
                          class: normalizeClass(["w-4 h-4", [item.disabled ? "fill-color-icon-disabled" : ""]])
                        }, null, 8, ["class"])), item.text ? (openBlock(), createElementBlock(
                          "span",
                          _hoisted_13,
                          toDisplayString(item.text),
                          1
                          /* TEXT */
                        )) : createCommentVNode("v-if", true)], 10, _hoisted_12)];
                      }),
                      _: 2
                      /* DYNAMIC */
                    },
                    1024
                    /* DYNAMIC_SLOTS */
                  );
                }),
                128
                /* KEYED_FRAGMENT */
              ))];
            }),
            _: 1
            /* STABLE */
          })];
        }),
        default: withCtx(function() {
          return [(openBlock(), createBlock(resolveDynamicComponent(_ctx.iconMore), {
            class: "w-4 h-4"
          })), _ctx.state.effectOptions[0].text ? (openBlock(), createElementBlock(
            "span",
            _hoisted_11,
            toDisplayString(_ctx.t("ui.base.more")),
            1
            /* TEXT */
          )) : createCommentVNode("v-if", true)];
        }),
        _: 1
        /* STABLE */
      })) : createCommentVNode("v-if", true)],
      2
      /* CLASS */
    )) : createCommentVNode("v-if", true)])) : createCommentVNode("v-if", true)],
    2
    /* CLASS */
  );
}
var Card = /* @__PURE__ */ _export_sfc(_sfc_main, [["render", _sfc_render]]);
var version = "3.8.0";
Card.model = {
  prop: "modelValue",
  event: "update:modelValue"
};
Card.install = function(Vue) {
  Vue.component(Card.name, Card);
};
Card.version = version;
export {
  Card as default
};
